﻿#ifndef WIDGETCONTAINER_H
#define WIDGETCONTAINER_H

#include <QWidget>
#ifdef Q_OS_WIN32

#include <QMainWindow>
#include <QList>
#include <Windows.h>
#include <TlHelp32.h>

class QProcess;
class QWindow;

class WidgetContainer : public QMainWindow
{
    Q_OBJECT
    struct handle_data {
        DWORD processId;
        HWND wndHandle;
    };
public:
    explicit WidgetContainer(QWidget *parent = nullptr);
    ~WidgetContainer();
signals:

public slots:
    bool createContainer(const QString &iAppName, const QStringList &iOpenParam = QStringList(), bool iAutoOpen = true);
protected:
    bool eventFilter(QObject *obj, QEvent *ev);
private:
    QList<DWORD> findProcessId(const QString &iAppName);
    HWND findWindowHandle(const QString & iClassName, const QString &iWindowName);
    DWORD startUpProcess(const QString &iAppName, const QString &iArguments = "");
    DWORD qStartUpProcessSyn(const QString &iAppName, const QStringList &iArguments = QStringList());
private:
    QProcess *mProcess = nullptr;
    QWindow *mHandleExternWindow = nullptr;
    QWidget *mWgtContainer = nullptr;
};
#endif
#endif // WIDGETCONTAINER_H

